(*......................................................................*)
(* MLj - a Standard ML to Java bytecode compiler                        *)
(* Copyright (C) 1999 Persimmon IT Inc.                                 *)
(*                                                                      *)
(* This program is free software; you can redistribute it and/or        *)
(* modify it under the terms of the GNU General Public License          *)
(* as published by the Free Software Foundation; either version 2       *)
(* of the License, or (at your option) any later version.               *)
(*                                                                      *)
(* This program is distributed in the hope that it will be useful,      *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of       *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *)
(* GNU General Public License for more details.                         *)
(*                                                                      *)
(* You should have received a copy of the GNU General Public License    *)
(* along with this program; if not, write to the Free Software          *)
(* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *)
(* MA 02111-1307, USA.                                                  *)
(*......................................................................*)

signature EFFECT =
sig

(* eqtype Effect *)
type Effect = word (* See if exposing this makes things more efficient *)

val none    : Effect
val any     : Effect

val partial : Effect
val reads   : Effect
val writes  : Effect
val allocs  : Effect
val io      : Effect
val throws  : Effect

val union   : Effect*Effect -> Effect
val intersection : Effect*Effect -> Effect
val sub     : Effect*Effect -> bool

val toString : Effect -> string

end